//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

//Remove warning about non-Variant values being pased where a Variant should be passed
#pragma warn -lvc
//Remove warning about function parameters not being used
#pragma warn -par

//Make sure sysvari.h compiles successfully
#include <utilcls.h>
#include "WordEgU.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  MSWord = MSWord.CreateObject("Word.Basic");
  MSWord.OleProcedure("AppShow");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  //Should be able to say:
  //  MSWord = Unassigned
  //but MS Office apps that have VBA support don't adhere to
  //the lifetime management aspects of the MS COM spec., so...
  MSWord.OleProcedure("FileExit", 2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  MSWord.OleProcedure("FileNew");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  MSWord.OleProcedure("Insert", "Hello world at ");
  MSWord.OleProcedure("InsertDateTime", "dddd, dd MMMM yyyy");
  MSWord.OleProcedure("Insert", "\r");
  MSWord.OleProcedure("Insert", Memo1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  //Update Word's doc stats
  MSWord.OleProcedure("DocumentStatistics");
  //Obtain doc stats using 2 variants
  Variant CurValues = MSWord.OlePropertyGet("CurValues");
  Variant DocStats = CurValues.OlePropertyGet("FileSummaryInfo");
  ListBox1->Items->Clear();
  ListBox1->Items->Add(String(DocStats.OlePropertyGet("NumPages")) + " pages");
  ListBox1->Items->Add(String(DocStats.OlePropertyGet("NumParas")) + " paragraphs");
  ListBox1->Items->Add(String(DocStats.OlePropertyGet("NumLines")) + " lines");
  ListBox1->Items->Add(String(DocStats.OlePropertyGet("NumWords")) + " words");
  ListBox1->Items->Add(String(DocStats.OlePropertyGet("NumChars")) + " characters");
}
//---------------------------------------------------------------------------
